from Globals import HTMLFile, Persistent, PersistentMapping
from OFS.SimpleItem import Item

from Acquisition import Implicit
from zCommerce import makeUID, NotImplemented
from Product import Product

from string import join

class Category(Implicit, Item):
    manage_options = (
        {'label':'Contents', 'action':'manage_categories'},
	{'label':'Settings',  'action':'manage_settings'}
	)


    manage_products = manage_categories  = HTMLFile('dtml/catalogCategories', globals())
    manage_settings        = HTMLFile('dtml/catalogProperties', globals())
    manage_addProductForm  = HTMLFile('dtml/addProductForm', globals())
    manage_addCategoryForm = HTMLFile('dtml/addCategoryForm', globals())
    manage_editProductForm = HTMLFile('dtml/editProductForm', globals())

    def __init__(self, id, label, category_id):
	self.id = id
	self.label = label
	self.category_id = category_id


    def __getitem__(self, key):
	try:
	    return self.getCategory(key).aq_base.__of__(self)
	except KeyError:
	    r = self.getProduct(key)
	    return r.aq_base.__of__(self)

    def getUID(self):
	"This is crummy hack at the moment."
	return self.category_id + '.' + self.id

    def manage_addProduct(self, sku, description, price, REQUEST=None):
        'Add a product to the Catalog'
	product = Product(sku, description, price, self.getUID())

	self.addProduct(product)
        if REQUEST is not None:
            return self.manage_products(self, REQUEST)

    def manage_updateProduct(self, sku, description, price, REQUEST=None):
        'Update an existing product in the Catalog'
        product = self.getProduct(sku)
        product.description = description
        product.price = price
        self.updateProduct(product)
        if REQUEST is not None:
            return self.manage_products(self, REQUEST)
            
        
    def manage_addCategory(self, id, label="", REQUEST=None):
	'Add a Category'
	category = Category(id, label, self.getUID())

        # This is a dirty hack to get around some Acquisition changes in 2.1.
        # category.cat_id = cat_id
        # category.cat_label = cat_label
        
	self.addCategory(category)
	if REQUEST is not None:
            return self.manage_categories(self, REQUEST)

    def manage_editCategory(self, id, label="", REQUEST=None):
        "Change a Category's Properties"
        category = self.aq_parent.getCategory(id)
        category.label = label

        self.updateCategory(category)
        if REQUEST is not None:
            return self.manage_categories(self, REQUEST)

    def queryProducts(self, qrystr):
	'Find items in the catalog that match the query'
	return self.ProductStorage.queryObjects(qrystr)









    # Abstract functions that need to be defined in sub classes.

    def addCategory(self, object):
	raise NotImplemented('addCategory', self)

    def getCategory(self, object_id):
	raise NotImplemented('getCategory', self)

    def updateCategory(self, object):
	raise NotImplemented('updateCategory', self)

    def deleteCategories(self, object_ids):
	raise NotImplemented('deleteCategories', self)

    def listCategories(self):
	raise NotImplemented('listCategories', self)


    def addProduct(self, object):
	raise NotImplemented('addProduct', self)

    def getProduct(self, object_id):
	raise NotImplemented('getProduct', self)

    def updateProduct(self, object):
	raise NotImplemented('updateProduct', self)

    def deleteProducts(self, object_ids):
	raise NotImplemented('deleteProducts', self)

    def listProducts(self):
	raise NotImplemented('listProducts', self)

