from Products.Session.sqlSessionStorage import sqlSessionInstance
from Globals import HTMLFile, Persistent, PersistentMapping, default__class_init__
from OrderEntry import OrderEntry
from Order import Order



class ShoppingSession(sqlSessionInstance):

    __allow_access_to_unprotected_subobjects__=1

    def __init__(self, id, user):
	sqlSessionInstance.__init__(self, id, user)
	self.current_order_id = ""

    
    def createOrder(self):
	order = Order(str(self.user))
	self.OrderStorage.addObject(order)
	return order.id

    def getOrder(self, order_id=None):
	if order_id is None:
	    if self.current_order_id == "":
		self.current_order_id = self.createOrder()
		
	    order_id = self.current_order_id

	query_str = "id='%s'" % order_id
	r = self.OrderStorage.queryObjects(query_str)

        # NOTE: It might be better to do this in a try statement
	if len(r) > 0:
	    return r[0]
	else:
	    return None


    def setOrder(self, REQUEST=None):
	order = self.getOrder()
	kw = REQUEST.form
	for key, value in kw.items():
	    if hasattr(order, key):
		setattr(order, key, value)

	kw = REQUEST.other
	for key, value in kw.items():
	    if hasattr(order, key):
		setattr(order, key, value)

	self.OrderStorage.updateObject(order)

    def listOrderEntries(self):
	order = self.getOrder()
	return order.listOrderEntries()
    
    def setOrderEntry(self, sku, quantity):
	quantity = int(quantity)
	order = self.getOrder()    

	order_entry = order.getOrderEntry(sku)
	if order_entry is not None:
	    if quantity <= 0:
		order.deleteOrderEntries(order_entry.id)
	    else:
		order_entry.quantity = quantity  
		order.updateOrderEntry(order_entry)
	else:
	    if quantity: 
		# It doesn't make sense to order 0 items.
		# Maybe in the future we can raise an error instead of
		# silently ignoring it.
		new_entry = OrderEntry(self.getProduct(sku), quantity)
		
		order.addOrderEntry(new_entry)

    def placeOrder(self):
	order = self.getOrder()
	
	if len(order.listOrderEntries()):
	    order.status = "PROCESSED"
	    self.OrderStorage.updateObject(order)
	    self.current_order = ""


default__class_init__(ShoppingSession)

