import time

from Globals import Persistent, HTMLFile
import OFS.SimpleItem
import OFS.Folder

from Acquisition import Implicit
from Products.ZSQLMethods.SQL import SQL

from Filters import str2filter

from Product import Product
from Category import Category

from sqlStorage import CategoryStorage, sqlCategory, ProductStorage


class sqlCatalog(sqlCategory, Persistent):
    """This is a Product Catalog that stores all it's data in a SQL DB"""
    manage_options = (
        {'label':'Contents', 'action':'manage_categories'},
	)

    meta_type = "SQL Product Catalog"

    def __init__(self, id, conn_id, title=""):
	self.id = id
	self.label = title
        self.conn_id = conn_id
	self.CategoryStorage = CategoryStorage(conn_id)
	self.ProductStorage  = ProductStorage(conn_id)

    def getUID(self): return self.id

    def enumQueries(self):
        list=[]
        type=SQL.meta_type
        for ob in self.__dict__.values():
            if hasattr(ob, 'meta_type') and ob.meta_type==type:
                list.append(ob)
        return list
