### Copyright  1999 CodeIt Computing, All rights reserved.

## By obtaining, using, and/or copying this software and/or its
## associated documentation, you agree that you have read, understood,
## and will comply with the following terms and conditions:

## Permission to use, copy, modify, and distribute this software and its
## associated documentation for any purpose and without fee is hereby
## granted, provided that the above copyright notice appears in all
## copies, and that both that copyright notice and this permission notice
## appear in supporting documentation, and that the name of CodeIt
## Computing not be used in advertising or publicity pertaining to
## distribution of the software without specific, written prior
## permission.

## CODEIT COMPUTING DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS
## SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND
## FITNESS. IN NO EVENT SHALL CODEIT COMPUTING BE LIABLE FOR ANY SPECIAL,
## INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING
## FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
## NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
## WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

__doc__="""zCommerce

* There's many more, but I'm tired of typing.

"""



import OFS.Folder
from OFS.DTMLMethod import DTMLMethod
from OFS.DTMLDocument import DTMLDocument
from OFS.Document import Document
from Globals import HTMLFile, Persistent, PersistentMapping
from Acquisition import Implicit
from Products.Session import Session
import time
from string import split


# Useful functions and stuff. They should probally go into some util
# module or something. They need to be defined before I load a few
# other modules.

class NotImplemented(Exception):
    def __init__(self, method_name, storage_instance):
	self.method_name = method_name
	self.classname = storage_instance.__class__.__name__

    def __str__(self):
	return "%s method not implemented in class '%s'" % (self.method_name,
							    self.classname)
    
def makeUID():

    # This is cheesy =) But one day maybe this function will grow-up
    # and become a real Unique ID generator.

    return str(abs(int(time.time())-900000000))




# TODO: These item should be loaded by the plugin machinery, when we
# get around to making it that is.
import sqlStorage
import Catalogs
import Templates


from ShoppingSession import ShoppingSession

# Call back routines for adding a new Shop object to
# Zope.

addzShopForm=HTMLFile('dtml/addzShop', globals())

# TODO: Update the addzShopForm to give the user the choice
# of adding new content.

def addzShop(self, id, conn_id, title="", import_content=0, REQUEST=None):
    """Add a zCommerce to Zope"""
    
    self._setObject(id, zShop(id, conn_id, title))
    z = getattr(self, id)

    if import_content:
        from doc_defaults import *
        z._setObject('cart.html', DTMLDocument(cart, __name__='cart.html'))
        z._setObject('index_html', DTMLMethod(index, __name__='index_html'))
        z._setObject('list_products.html', DTMLMethod(list_products, __name__='list_products.html'))
        z._setObject('place_order.html', DTMLDocument(place_order, __name__='place_order.html'))
        z._setObject('showCart', DTMLMethod(showCart, __name__='showCart'))
        z._setObject('standard_html_footer', DTMLMethod(footer, __name__='standard_html_footer'))
        z._setObject('standard_html_header', DTMLMethod(header, __name__='standard_html_header'))
        z._setObject('thankyou.html', DTMLDocument(thankyou, __name__='thankyou.html'))
        z._setObject('update_cart.html', DTMLMethod(update_cart, __name__='update_cart.html'))
        z._setObject('view_product.html', DTMLDocument(view_product, __name__='view_product.html'))

	# We need to save the changes to the databse before 
	# can import content.
	# get_transaction().commit()
	# z.manage_importObject(file='content.zexp')
    
    if REQUEST is not None: 
	# Display the folder that contains the new zCommerce
	return self.manage_main(self,REQUEST)


class zShop(
    Session.Session
    ):
    """A Shop
    """
    
    __allow_access_to_unprotected_subobjects__=1
    #icon='misc_/Session/icon'   
    meta_type='zShop'	# Objects Name in the Zope list
    
    manage_options = ({'label':'Contents',      'action':'manage_main'},
                      {'label':'Catalogs',      'action':'catalogs/manage_main'},
                      {'label':'Sessions',      'action':'manage_sessions'},
                      {'label':'Import/Export', 'action':'manage_importExportForm'},
                      {'label':'Properties',    'action':'manage_propertiesForm'},
		      {'label':'About',         'action':'manage_about', 'target':'_top'} 
                      )

    # TODO: This should be done by the plugin do-hickeys.

    Instance = ShoppingSession
    
    def __init__(self, id, conn_id, title=''):
        Session.Session.__init__(self, id, title)
        self.conn_id = conn_id
        
        self.sessions = Session.sqlSessionStorage(conn_id)

        self.catalogs = Catalogs.Catalogs(conn_id)
	self.OrderStorage = sqlStorage.OrderStorage(conn_id)

    def queryProducts(self, strQuery=''):
	"""Search for matching products in all the catalogs"""
	
	results = []
	catalogs = self.catalogs.objectValues()
	for catalog in catalogs:
	    rr = catalog.queryProducts(strQuery)
	    for r in rr:
		results.append(r)
	    
	return results

    def getProduct(self, sku):
	"""Search through all the catalogs and find a product."""

	results=None
	catalogs=self.catalogs.objectValues()
	for catalog in catalogs:
	    results = catalog.getProduct(sku)
	    if results is not None:
		break
	    
	return results

    def getCategory(self, id):
	"""Search through all the catalogs and find a product."""

        categories = split(id, '.')
        category = getattr(self.catalogs, categories[0], None)
	
	# Walk the object's sub objects if necessary

	categories = categories[1:]

	for subcategory in categories:
	    if category is not None:
		category = category.getCategory(subcategory)
	    else:
		break

	return category


    def listCategories(self):
	return self.catalogs.objectValues()

    def manage_about(self, REQUEST=None, RESPONSE=None):
	"Give a little credit, where credits due =)"
	return RESPONSE.redirect("http://www.codeit.com")
